// Dude Demo 0.03
// By: Andrew Orr [a.k.a. The Black Frog] http://www.TheBlackFrog.8m.com
//
// I made this using Dovoto's PERN Project Day 3 source.
// Then i added some of day 4.
//
// Greetz:
// Dovoto, Joat, JSensebe, JayC, Sonikku, BigRedPmp,  #gbadev on efnet, Theodosius
//
// note: all comments with // were put in by me, all comments with /// were 
// the origional comments found in pern 3 & 4 [i removed some of them]

#include"gba.h"
#include"screenmode.h"          // all of Dovoto's original includes with 
#include"keypad.h"		// defines and macros and funxions
#include"sprite.h"

#include"dude.h"  // dude.h contains the sprite data and palette
#include"room1.h" // room1.h contains the room 1 data and palette and map
#include"room1.map"

/// declare our functions so the c compiler knows what we are talking about

void InitializeSprites(void);
void WaitForVsync(void);
void CopyOAM(void);
void GetInput(void);
void MoveSprite(OAMEntry* sp, int x, int y);

/// these are global so i do not have to pass them to GetInput
s16 dudeX = 112;
s16 dudeY = 72;

u8 currentdirection = 0;   // dude's direction: 0=down, 1=up, 2=left, 3=right
u8 currentframe=0;
u8 tempcounter=0;
u8 tempvar=0;
u8 dudemoving=0;

u16 *pal=(u16*)0x5000000;
u16 *tiles=(u16*)0x6004000;
u16 *map=(u16*)0x6000000;

void CopyBG(u8 room)
{
	u16 i;
	for(i=0;i<256;i++) pal[i]=room1Palette[i];
	for(i=0;i<8*8*8;i++) tiles[i]=room1Data[i];
	for(i = 0; i <32*22; i++)
        {
        	map[i] = room1Map[i];
        }
}

/// main entry point from the boot.asm startup file
void C_Entry(void)
{
	u16 index = 0;  /// some looping variables for loops :)
	u16 loop;
	
// sets mode 4 and enables background 2 and sprites, sets sprites data to 1D
	SetMode(MODE_0 | BG0_ENABLE | OBJ_ENABLE | OBJ_MAP_1D);
	REG_BG0CNT = 0x84; 
	CopyBG(1);

// loads sprite palette
	for(loop = 0; loop < 256; loop++)
		OBJPaletteMem[loop] = dudePalette[loop];

	
	InitializeSprites();  ///set all 128 sprites to offscreen

// sets first sprite attributes to 256 color, 16x16 pixels, charecter 0 and
// to location dudeX, dudeY
	sprites[0].attribute0 = COLOR_256 | SQUARE | dudeY;  
	sprites[0].attribute1 = SIZE_16 | dudeX;
	sprites[0].attribute2 = 0;

	

// copy sprite data to OAM, 3072 because there's 4 different directions, 
// and each has 3 frames of animation, so 16x16 [per frame] x 3[frames per
// direction] x 4[directions] = 3072
		for(index = 0; index < 3072; index++)
		{
			OAMData[index] = dudeData[index];  
			
		}
///Main Game loop	
	while(1)
	{

// gets any keys being pressed and changes dudeX and dudeY as well as 
// currentdirection accordingly
		GetInput();    

// sets the new location and direction for sprite 0 in a temporary array
		MoveSprite(&sprites[0],dudeX,dudeY);

// waits for the screen the stop drawing
		WaitForVsync();	
		
		tempcounter++;
		if(tempcounter>59) tempcounter=0;	

// copys attributes from temporary array into oam
		CopyOAM();				
	}
}

///Set sprites to off screen

void InitializeSprites(void)
{
	int loop;
	for(loop = 0; loop < 128; loop++)
	{
		sprites[loop].attribute0 = 160;  //y to > 159
		sprites[loop].attribute1 = 240;  //x to > 239
	}
}

///wait for the screen to stop drawing

/// 0x4000006 is vertical trace counter; when it hits 160
/// 160 the vblanc starts
/// the vertical blank period has begun. done in asm just 
/// because:)

void WaitForVsync(void)
{
	__asm 
	{
		mov 	r0, #0x4000006   
		scanline_wait:	       	
		ldrh	r1, [r0]
		cmp	r1, #160
		bne 	scanline_wait
	}			
}

/// Copy our sprite array to OAM
void CopyOAM(void)
{
	u16 loop;
	u16* temp;
	temp = (u16*)sprites;
	for(loop = 0; loop < 128*4; loop++)
	{
		OAM[loop] = temp[loop];
	}
}

/// Test for key presses
void GetInput(void)
{
        if(tempvar == 0)
	{
	if(!(*KEYS & KEY_UP))
	{

// makes sure you're not gonna go off the screen and then moves 
// you're sprite back 8 pixels, and changes the direction to up
// and increments the frame as neccessary

                if(dudeY >= 8) dudemoving = 1;
		currentdirection=1;
	}
	if(!(*KEYS & KEY_DOWN))
	{
                if(dudeY <= 136) dudemoving = 1;
		currentdirection=0;
	}
	if(!(*KEYS & KEY_LEFT))
	{
                if(dudeX >= 8) dudemoving = 1;
		currentdirection=2;
	}
	if(!(*KEYS & KEY_RIGHT))
	{
                if(dudeX <= 216) dudemoving = 1;
		currentdirection=3;
	}
	}
}

///move the sprite
void MoveSprite(OAMEntry* sp, int x, int y)
{
	sp->attribute1 = sp->attribute1 & 0xFE00;  ///clear the old x value
	sp->attribute1 = sp->attribute1 | x;
	
	sp->attribute0 = sp->attribute0 & 0xFF00;  ///clear the old y value
	sp->attribute0 = sp->attribute0 | y;
        if(dudemoving==1)
	{
		if(tempvar==0)
		{
			tempvar=1;
			tempcounter=0;
		}
		if(tempcounter==1)
		{
			if(currentdirection==0) dudeY +=1;
			if(currentdirection==2) dudeX -=1;
			if(currentdirection==3) dudeX +=1;
		}
		if(tempcounter>1)
			if(tempcounter<5) currentframe=1;

		if(tempcounter==4)
		{
			if(currentdirection==0) dudeY +=1;
			if(currentdirection==1) dudeY -=1;
			if(currentdirection==2) dudeX -=1;
			if(currentdirection==3) dudeX +=1;
		}
		if(tempcounter>4)
			if(tempcounter<8) currentframe=2;

		if(tempcounter==7)
		{
			if(currentdirection==0) dudeY +=1;
			if(currentdirection==1) dudeY -=1;
			if(currentdirection==2) dudeX -=1;
			if(currentdirection==3) dudeX +=1;
		}
		if(tempcounter>7)
			if(tempcounter<11) currentframe=1;

		if(tempcounter==10)
		{
			if(currentdirection==0) dudeY +=1;
			if(currentdirection==1) dudeY -=1;
			if(currentdirection==2) dudeX -=1;
			if(currentdirection==3) dudeX +=1;
		}
		if(tempcounter>10)
			if(tempcounter<14) currentframe=2;

		if(tempcounter==13)
		{
			if(currentdirection==0) dudeY +=1;
			if(currentdirection==1) dudeY -=1;
			if(currentdirection==2) dudeX -=1;
			if(currentdirection==3) dudeX +=1;
		}
		if(tempcounter>13)
			if(tempcounter<17) currentframe=1;

		if(tempcounter==16)
		{
			if(currentdirection==0) dudeY +=1;
			if(currentdirection==1) dudeY -=1;
			if(currentdirection==2) dudeX -=1;
			if(currentdirection==3) dudeX +=1;
		}
		if(tempcounter>16)
			if(tempcounter<20) currentframe=2;

		if(tempcounter==19)
		{
			if(currentdirection==0) dudeY +=1;
			if(currentdirection==1) dudeY -=1;
			if(currentdirection==2) dudeX -=1;
			if(currentdirection==3) dudeX +=1;
		}
		if(tempcounter>19)
			if(tempcounter<23) currentframe=1;

		if(tempcounter==22)
		{
			if(currentdirection==0) dudeY +=1;
			if(currentdirection==1) dudeY -=1;
			if(currentdirection==2) dudeX -=1;
			if(currentdirection==3) dudeX +=1;
		}
		if(tempcounter>22)
			if(tempcounter<26) currentframe=2;

		if(tempcounter==25)
			if(currentdirection==1) dudeY -=1;

		if(tempcounter>25)
			if(tempcounter<29) currentframe=0;

		if(tempcounter>28)
		{
			tempvar=0;
                        dudemoving=0;
		}
	
	}

// sets the charecter to *8 because 256 color 16x16 sprite = 8
	sp->attribute2 = (currentdirection*24)+(currentframe*8);
	
}
